/*
 * Copyright (C) 2010 Eiichiro Uchiumi. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 *     
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.eiichiro.acidhouse.metamodel.processing;

import javax.lang.model.element.Element;
import javax.tools.Diagnostic.Kind;

/**
 * {@code Problem} represents the metamodel generation problem.
 * This problem is reported by {@code javax.annotation.processing.Messager}.
 * 
 * @author <a href="mailto:eiichiro@eiichiro.org">Eiichiro Uchiumi</a>
 */
public class Problem {

	private final Kind kind;
	
	private final String message;
	
	private final Element element;
	
	public Problem(Kind kind, String message, Element element) {
		this.kind = kind;
		this.message = message;
		this.element = element;
	}

	public Kind getKind() {
		return kind;
	}

	public String getMessage() {
		return message;
	}

	public Element getElement() {
		return element;
	}
	
}
